﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr176_1
{
    // Объявление делегата: 
    delegate int MyDelegate();

    // Класс с главным методом: 
    class Program
    {
        // Статический метод результатом возвращает ссылку на
        // экземпляр делегата:
        static MyDelegate calculate(int n) {
            // Локальная переменная: 
            int count = 0;
            // Результат реализован через анонимный метод: 
            return delegate() {
                count += n; 
                return count;
            };
        }
        // Главный метод: 
        static void Main()
        {
            // Переменная типа делегата:
            MyDelegate next = calculate(1); 
            for (int i = 1; i <= 5; i++)
            {
                // Вызов экземпляра делегата:
                Console.Write(next() + " ");
            }
            Console.WriteLine();
            // Новое значение переменной типа делегата: 
            next = calculate(3);
            for (int i = 1; i <= 5; i++)
            {
                // Вызов экземпляра делегата:
                Console.Write(next() + " ");
            }
            Console.WriteLine();
            // Задержка:
            Console.ReadLine();
        }
    }
}
